PIP-INSTALL(1)

NAME
pip-install - description of pip install command

DESCRIPTION

Install packages from:

•   PyPI (and other indexes) using requirement specifiers.

•   VCS project urls.

•   Local project directories.

•   Local or remote source archives.

    pip also supports installing from "requirements files", which provide an easy way to specify a whole environment to be installed.

USAGE

pip [options] <requirement specifier> [package-index-options] ...
pip [options] -r <requirements file> [package-index-options] ...
pip [options] [-e] <vcs project url> ...
pip [options] [-e] <local project path> ...
pip [options] <archive url/path> ...

OPTIONS

-r, --requirement <file>
    Install from the given requirements file. This option can be used multiple times.

-c, --constraint <file>
    Constrain versions using the given constraints file. This option can be used multiple times.

--no-deps
    Don't install package dependencies.

--pre
    Include pre-release and development versions. By default, pip only finds stable versions.

-e, --editable <path/url>
    Install a project in editable mode (i.e. setuptools "develop mode") from a local project path or a VCS url.

-t, --target <dir>
    Install packages into <dir>. By default this will not replace existing files/folders in <dir>. Use --upgrade to replace existing packages in <dir> with new versions.

--user
    Install to the Python user install directory for your platform. Typically ~/.local/, or %APPDATA%Python on Windows. (See the Python documentation for site.USER_BASE for full details.)

--root <dir>
    Install everything relative to this alternate root directory.

--prefix <dir>
    Installation prefix where lib, bin and other top-level folders are placed

-b, --build <dir>
    Directory to unpack packages into and build in. Note that an initial build still takes place in a temporary directory. The location of temporary directories can be controlled by setting the TMPDIR environment variable (TEMP on Windows) appropriately. When passed, build directories are not cleaned in case of failures.

--src <dir>
    Directory to check out editable projects into. The default in a virtualenv is "<venv path>/src". The default for global installs is "<current dir>/src".

-U, --upgrade
    Upgrade all specified packages to the newest available version. The handling of dependencies depends on the upgrade-strategy used.

--upgrade-strategy <upgrade_strategy>
    Determines how dependency upgrading should be handled [default: only-if-needed]. "eager" - dependencies are upgraded regardless of whether the currently installed version satisfies the requirements of the upgraded package(s). "only-if-needed" - are upgraded only when they do not satisfy the requirements of the upgraded package(s).

--force-reinstall
    Reinstall all packages even if they are already up-to-date.

-I, --ignore-installed
    Ignore the installed packages (reinstalling instead).

--ignore-requires-python
    Ignore the Requires-Python information.

--no-build-isolation
    Disable isolation when building a modern source distribution. Build dependencies specified by PEP 518 must be already installed if this option is used.

--install-option <options>
    Extra arguments to be supplied to the setup.py install command (use like --install-option="--install-scripts=<sys.prefix>/local/bin"). Use multiple --install-option options to pass multiple options to setup.py install. If you are using an option with a directory path, be sure to use absolute path.

--global-option <options>
    Extra global options to be supplied to the setup.py call before the install command.

--compile
    Compile Python source files to bytecode

--no-compile
    Do not compile Python source files to bytecode

--no-warn-script-location
    Do not warn when installing scripts outside PATH

--no-warn-conflicts
    Do not warn about broken dependencies

--no-binary <format_control>
    Do not use binary packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all binary packages, :none: to empty the set, or one or more package names with commas between them. Note that some packages are tricky to compile and may fail to install when this option is used on them.

--only-binary <format_control>
    Do not use source packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all source packages, :none: to empty the set, or one or more package names with commas between them. Packages without binary distributions will fail to install when this option is used on them.

--prefer-binary
    Prefer older binary packages over newer source packages.

--no-clean
    Don't clean up build directories).

--require-hashes
    Require a hash to check each requirement against, for repeatable installs. This option is implied when any package in a requirements file has a --hash option.

--progress-bar <progress_bar>
    Specify type of progress to be displayed [off|on|ascii|pretty|emoji] (default: on)

AUTHOR
pip developers

COPYRIGHT
2008-2018, PyPA